<?php

require_once XOOPS_ROOT_PATH.'/class/xoopsformloader.php';

class LostpassView
{
	var $mUser;
	var $mXoopsConfig;
	
	function LostpassView(&$user)
	{
		$this->mUser=&$user;
	}
	
	function executeError()
	{
		XCube_Utils::redirectHeader("user.php",2,_US_SORRYNOTFOUND);
	}
	
	function executeSuccess()
	{
		// XCube_Utils::redirectHeader("user.php",2,_US_SORRYNOTFOUND);
	}

	function executeInput()
	{
		global $xoopsConfig;	///< @todo

		$config_handler =& xoops_gethandler('config');
		$xoopsConfigUser =& $config_handler->getConfigsByCat(XOOPS_CONF_USER);

    	require_once XOOPS_ROOT_PATH.'/include/comment_constants.php';

    	echo '<a href="userinfo.php?uid='.$this->mUser->getVar('uid').'">'. _US_PROFILE .'</a>&nbsp;<span style="font-weight:bold;">&raquo;&raquo;</span>&nbsp;'. _US_EDITPROFILE .'<br /><br />';
    	$form = new XoopsThemeForm(_US_EDITPROFILE, 'userinfo', 'edituser.php');
    	$uname_label = new XoopsFormLabel(_US_NICKNAME, $this->mUser->getVar('uname'));
    	$form->addElement($uname_label);
    	$name_text = new XoopsFormText(_US_REALNAME, 'name', 30, 60, $this->mUser->getVar('name', 'E'));
    	$form->addElement($name_text);
    	$email_tray = new XoopsFormElementTray(_US_EMAIL, '<br />');
    	if ($xoopsConfigUser['allow_chgmail'] == 1) {
    		$email_text = new XoopsFormText('', 'email', 30, 60, $this->mUser->getVar('email'));
    	} else {
    		$email_text = new XoopsFormLabel('', $this->mUser->getVar('email'));
    	}
    	$email_tray->addElement($email_text);
    	$email_cbox_value = $this->mUser->user_viewemail() ? 1 : 0;
    	$email_cbox = new XoopsFormCheckBox('', 'user_viewemail', $email_cbox_value);
    	$email_cbox->addOption(1, _US_ALLOWVIEWEMAIL);
    	$email_tray->addElement($email_cbox);
    	$form->addElement($email_tray);
    	$url_text = new XoopsFormText(_US_WEBSITE, 'url', 30, 100, $this->mUser->getVar('url', 'E'));
    	$form->addElement($url_text);
    
    	$timezone_select = new XoopsFormSelectTimezone(_US_TIMEZONE, 'timezone_offset', $this->mUser->getVar('timezone_offset'));
    	$icq_text = new XoopsFormText(_US_ICQ, 'user_icq', 15, 15, $this->mUser->getVar('user_icq', 'E'));
    	$aim_text = new XoopsFormText(_US_AIM, 'user_aim', 18, 18, $this->mUser->getVar('user_aim', 'E'));
    	$yim_text = new XoopsFormText(_US_YIM, 'user_yim', 25, 25, $this->mUser->getVar('user_yim', 'E'));
    	$msnm_text = new XoopsFormText(_US_MSNM, 'user_msnm', 30, 100, $this->mUser->getVar('user_msnm', 'E'));
    	$location_text = new XoopsFormText(_US_LOCATION, 'user_from', 30, 100, $this->mUser->getVar('user_from', 'E'));
    	$occupation_text = new XoopsFormText(_US_OCCUPATION, 'user_occ', 30, 100, $this->mUser->getVar('user_occ', 'E'));
    	$interest_text = new XoopsFormText(_US_INTEREST, 'user_intrest', 30, 150, $this->mUser->getVar('user_intrest', 'E'));
    	$sig_tray = new XoopsFormElementTray(_US_SIGNATURE, '<br />');

    	require_once XOOPS_ROOT_PATH.'/include/xoopscodes.php';

    	$sig_tarea = new XoopsFormDhtmlTextArea('', 'user_sig', $this->mUser->getVar('user_sig', 'E'));
    	$sig_tray->addElement($sig_tarea);
    	$sig_cbox_value = $this->mUser->getVar('attachsig') ? 1 : 0;
    	$sig_cbox = new XoopsFormCheckBox('', 'attachsig', $sig_cbox_value);
    	$sig_cbox->addOption(1, _US_SHOWSIG);
    	$sig_tray->addElement($sig_cbox);
    	$umode_select = new XoopsFormSelect(_US_CDISPLAYMODE, 'umode', $this->mUser->getVar('umode'));
    	$umode_select->addOptionArray(array('nest'=>_NESTED, 'flat'=>_FLAT, 'thread'=>_THREADED));
    	$uorder_select = new XoopsFormSelect(_US_CSORTORDER, 'uorder', $this->mUser->getVar('uorder'));
    	$uorder_select->addOptionArray(array(XOOPS_COMMENT_OLD1ST => _OLDESTFIRST, XOOPS_COMMENT_NEW1ST => _NEWESTFIRST));
    	// RMV-NOTIFY
    	// TODO: add this to admin user-edit functions...
    	require_once XOOPS_ROOT_PATH . "/language/" . $xoopsConfig['language'] . '/notification.php';
    	require_once XOOPS_ROOT_PATH . '/include/notification_constants.php';
    	$notify_method_select = new XoopsFormSelect(_NOT_NOTIFYMETHOD, 'notify_method', $this->mUser->getVar('notify_method'));
    	$notify_method_select->addOptionArray(array(XOOPS_NOTIFICATION_METHOD_DISABLE=>_NOT_METHOD_DISABLE, XOOPS_NOTIFICATION_METHOD_PM=>_NOT_METHOD_PM, XOOPS_NOTIFICATION_METHOD_EMAIL=>_NOT_METHOD_EMAIL));
    	$notify_mode_select = new XoopsFormSelect(_NOT_NOTIFYMODE, 'notify_mode', $this->mUser->getVar('notify_mode'));
    	$notify_mode_select->addOptionArray(array(XOOPS_NOTIFICATION_MODE_SENDALWAYS=>_NOT_MODE_SENDALWAYS, XOOPS_NOTIFICATION_MODE_SENDONCETHENDELETE=>_NOT_MODE_SENDONCE, XOOPS_NOTIFICATION_MODE_SENDONCETHENWAIT=>_NOT_MODE_SENDONCEPERLOGIN));
    	$bio_tarea = new XoopsFormTextArea(_US_EXTRAINFO, 'bio', $this->mUser->getVar('bio', 'E'));
    	$cookie_radio_value = empty($_COOKIE[$xoopsConfig['usercookie']]) ? 0 : 1;
    	$cookie_radio = new XoopsFormRadioYN(_US_USECOOKIE, 'usecookie', $cookie_radio_value, _YES, _NO);
    	$pwd_text = new XoopsFormPassword('', 'password', 10, 32);
    	$pwd_text2 = new XoopsFormPassword('', 'vpass', 10, 32);
    	$pwd_tray = new XoopsFormElementTray(_US_PASSWORD.'<br />'._US_TYPEPASSTWICE);
    	$pwd_tray->addElement($pwd_text);
    	$pwd_tray->addElement($pwd_text2);
    	$mailok_radio = new XoopsFormRadioYN(_US_MAILOK, 'user_mailok', $this->mUser->getVar('user_mailok'));
    	$uid_hidden = new XoopsFormHidden('uid', $this->mUser->getVar('uid'));
    	$op_hidden = new XoopsFormHidden('op', 'saveuser');
    	$submit_button = new XoopsFormButton('', 'submit', _US_SAVECHANGES, 'submit');
    
    	$form->addElement($timezone_select);
    	$form->addElement($icq_text);
    	$form->addElement($aim_text);
    	$form->addElement($yim_text);
    	$form->addElement($msnm_text);
    	$form->addElement($location_text);
    	$form->addElement($occupation_text);
    	$form->addElement($interest_text);
    	$form->addElement($sig_tray);
    	$form->addElement($umode_select);
    	$form->addElement($uorder_select);
    	$form->addElement($notify_method_select);
    	$form->addElement($notify_mode_select);
    	$form->addElement($bio_tarea);
    	$form->addElement($pwd_tray);
    	$form->addElement($cookie_radio);
    	$form->addElement($mailok_radio);
    	$form->addElement($uid_hidden);
    	$form->addElement($op_hidden);
    	$form->addElement($submit_button);
    	if ($xoopsConfigUser['allow_chgmail'] == 1) {
    		$form->setRequired($email_text);
    	}
    	$form->display();
	}
}

?>
